//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <vcl\clipbrd.hpp>
#pragma hdrstop

#include "NymRemsDlgs.h"
#include "NymWizDlgs.h"
#include "pgpbuffers.h"
#include "pgpfiles.h"
#include "FileMan.h"
#include "global.h"
#include "view.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TNymRemsDlg *NymRemsDlg;
const AnsiString NymRemsPaste = "NymRemsPaste";
//---------------------------------------------------------------------------
AnsiString __fastcall GetRemailerAddress(TForm *Owner)
{
   int len=0,pos=0;
   AnsiString remailer;
   NymRemsDlg = new TNymRemsDlg(Owner);
   TStringList *rems = new TStringList();
   if (FileExists(clisttxt)) rems->LoadFromFile(clisttxt);
   if (rems->Count>1) len = rems->Strings[1].LowerCase().Pos("history")-6;
   for (int i=0; i<rems->Count; i++)
   {
      remailer = rems->Strings[i];
      if (remailer.Pos("%")==0) continue;
      if (remailer.Trim().IsEmpty()) break;
      if (pos==0)
      {
         bool waiting = false;
         for (int c=0; c<remailer.Length(); c++)
         {
            if (remailer[c]==' ') waiting = true;
            if (waiting && remailer[c]!=' ')
            {
               pos = c;
               break;
            }
         }
      }
      if (pos) remailer.Insert("  ",pos);
      NymRemsDlg->RemailerList->Items->Add(remailer.SubString(1,len).Trim());
   }
   NymRemsDlg->ShowModal();
   remailer = NymRemsDlg->remailer.LowerCase();
   Clipboard()->AsText = remailer;
   delete rems;
   delete NymRemsDlg;
   return remailer;
}
//---------------------------------------------------------------------------
__fastcall TNymRemsDlg::TNymRemsDlg(TComponent* Owner)
  : TForm(Owner)
{
   CenterDialog(this,(TForm*)Owner);
   AnsiString line,shrt,caps,rem,paste = GetAppIni(NymRemsPaste,"short");
   if (paste=="address") AddressBtn->Checked = true;
   else ShortBtn->Checked = true;

   // list of remailer caps strings in form shortname=caps string
   CapsList->Clear();
   RemailerList->Clear();
   remcaps = new TStringList();
   remperf = new TStringList();
   TStringList *tmp = new TStringList();
   if (FileExists(clisttxt)) tmp->LoadFromFile(clisttxt);
   for (int i=0; i<tmp->Count; i++)
   {
      line = tmp->Strings[i];
      if (line.Pos("$remailer{")==1)
      {
         shrt = GetToken(1,line,"\"");
         caps = GetToken(3,line,"\"");
         remcaps->Add(shrt+"="+GetToken(1,caps,">").Trim());
      }
      else
      if (line.Pos("%"))//==line.Length())
      {
         shrt = GetToken(0,line," ");
         remperf->Add(shrt+"=recent performance :  "+line.SubString(line.Length()-29,64));
      }
   }
   delete tmp;
}
//---------------------------------------------------------------------------
void __fastcall TNymRemsDlg::RemailerListDblClick(TObject *Sender)
{
   ModalResult = mrOk;
}
//---------------------------------------------------------------------------
void __fastcall TNymRemsDlg::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (ModalResult==mrOk && RemailerList->ItemIndex>=0)
   {
      remailer = GetParam(ShortBtn->Checked?0:1,
         RemailerList->Items->Strings[RemailerList->ItemIndex]," "
      );
   }
   delete remperf;
   delete remcaps;
}
//---------------------------------------------------------------------------
void __fastcall TNymRemsDlg::PasteBtnClick(TObject *Sender)
{
   if (Sender==ShortBtn) PutAppIni(NymRemsPaste,"short");
   else PutAppIni(NymRemsPaste,"address");
}
//---------------------------------------------------------------------------
void __fastcall TNymRemsDlg::RemailerListClick(TObject *Sender)
{
   AnsiString rem;
   if (RemailerList->ItemIndex>=0)
      rem = GetParam(0,RemailerList->Items->Strings[RemailerList->ItemIndex]," ");
   if (!rem.IsEmpty())
   {
      CapsList->Clear();
      CapsList->Lines->Text = remcaps->Values[rem];
      CapsList->Lines->Add(remperf->Values[rem]);
   }
}
//---------------------------------------------------------------------------