//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "SMTPmods.h"
#include "QuickWins.h"
#include "Msgman.h"
#include "Global.h"
//---------------------------------------------------------------------------
#pragma link "SmtpProt"
#pragma resource "*.dfm"
TSMTPmod *SMTPmod;
//---------------------------------------------------------------------------
void __fastcall SMTP::SendMail(TQuickWin *Owner)
{
   SMTPmod = new TSMTPmod(Owner);
   SMTPmod->GetNextMessage();
}
//---------------------------------------------------------------------------
__fastcall TSMTPmod::TSMTPmod(TComponent* Owner)
	: TDataModule(Owner)
{
   cap = "";
   mainwin = (TQuickWin*)Owner;
   Global->SetRedraw(mainwin,0);
   mainwin->Editor->Align = alNone;
   mainwin->ToolBar->Visible = false;
   mainwin->SMTPBar->Visible = true;
   mainwin->CancelSendBtn->Visible = true;
   mainwin->Editor->Align = alClient;
   mainwin->Editor->Visible = true;
   mainwin->Editor->Clear();
   mainwin->CancelSendBtn->OnClick = SMTPFileCancelSendItemClick;
   mainwin->SMTPFileCancelSendItem->OnClick = SMTPFileCancelSendItemClick;
   mainwin->SMTPFileCancelSendItem->Enabled = true;
   mainwin->OkSentBtn->OnClick = OkSentBtnClick;
   mainwin->OkSentBtn->Visible = false;
   for (int i=0; i<mainwin->MainMenu->Items->Count; i++)
      mainwin->MainMenu->Items->Items[i]->Visible = false;
   mainwin->SMTPFileMenu->Visible = true;
   progressbar = mainwin->ProgressBar;
   display = mainwin->Editor->Lines;
   Global->SetRedraw(mainwin,1);

   messages = new TStringList();
   message = new TStringList();
   msg = new TMsgManager(message);
   BytesSent = BytesTotal = AllSent = AllTotal = lasterror = 0;
   canceled = aborted = connecting = false;

   AnsiString line;
   Global->DB->LoadQueuedMessageNames(messages);
   msgcount = messages->Count;
   for (int i=0; i<msgcount; i++)
   {
      line = messages->Strings[i];
      int len = Global->GetToken(3,line,"").ToIntDef(0);
      int hed = Global->GetToken(4,line,"").ToIntDef(0);
      AllTotal += len-hed;
   }
   progressbar->Show();
}
//---------------------------------------------------------------------------
__fastcall TSMTPmod::~TSMTPmod()
{
   Global->SetRedraw(mainwin,0);
   for (int i=0; i<mainwin->MainMenu->Items->Count; i++)
      mainwin->MainMenu->Items->Items[i]->Visible = true;
   mainwin->CancelSendBtn->OnClick = NULL;
   mainwin->SMTPFileCancelSendItem->OnClick = NULL;
   mainwin->SMTPFileMenu->Visible = false;
   mainwin->Editor->Align = alNone;
   mainwin->SMTPBar->Visible = false;
   mainwin->ToolBar->Visible = true;
   mainwin->ToolBar->Align = alTop;
   mainwin->Editor->Align = alClient;
   mainwin->CancelSendBtn->OnClick = NULL;
   mainwin->OkSentBtn->OnClick = NULL;
   Global->SetRedraw(mainwin,1);
   //progressbar = NULL;
   //display = NULL;
   delete msg;
   delete message;
   delete messages;
}
//---------------------------------------------------------------------------
void __fastcall TSMTPmod::OkSentBtnClick(TObject *Sender)
{
   mainwin->SetWindowMode(0);
   Free();
}
//---------------------------------------------------------------------------
void __fastcall TSMTPmod::SMTPFileCancelSendItemClick(TObject *Sender)
{
   SetCaption("Send canceled!");
   if (SMTP->Connected) SMTP->Abort();
   mainwin->datakey = "";
   canceled = true;
   ShowExitInfo();
}
//---------------------------------------------------------------------------
bool __fastcall TSMTPmod::GetNextMessage()
{
   progressbar->Position = 0;
   Timer->Enabled = true;
   return true;
}
//---------------------------------------------------------------------------
void __fastcall TSMTPmod::TimerTimer(TObject *Sender)
{
   Timer->Enabled = false;
   SendNextMessage();
}
//---------------------------------------------------------------------------
bool __fastcall TSMTPmod::SendNextMessage()
{
   if (canceled || aborted) return false;
   if (!messages->Count)
   {
      ShowExitInfo();
      return false;
   }
   messagekey = messages->Strings[0];
   Global->DB->UnQueueMessage(messagekey,message);
   Global->DB->QueueProblem(message);
   messages->Delete(0);
   PrepareAndConnect();
   return true;
}
//---------------------------------------------------------------------------
void __fastcall TSMTPmod::DISPLAY(AnsiString text)
{
   if (canceled || aborted) return;
   display->Add(" "+text);
}
//---------------------------------------------------------------------------
void __fastcall TSMTPmod::Abort(int Error)
{
   if (!Error) return;
   DISPLAY("Winsock Error: "+AnsiString(Error)+" "+WSocketErrorDesc(Error));
   DISPLAY("Send aborted!");
   //SetCaption("Send aborted");
   lasterror = Error;
   aborted = true;
}
//---------------------------------------------------------------------------
bool __fastcall TSMTPmod::PrepareAndConnect()
{
   while (message->Count && message->Strings[0].Pos("#")==1)
      message->Delete(0);
   BytesSent = 0; BytesTotal = msg->body->Text.Length();
   AnsiString fromName,signOn = msg->headers->GetDat("Sign-On: ");
   SMTP->Host = msg->host;
   fromName = msg->from;
   SMTP->FromName = msg->headers->GetAddress(fromName);
   SMTP->SignOn = signOn.IsEmpty()?Global->GetDomain(SMTP->FromName):signOn;
   SMTP->HdrFrom = fromName;
   SMTP->HdrSubject = msg->subject;
   SMTP->HdrTo = msg->to;
   msg->headers->GetRecipients(SMTP->RcptName);
   msg->headers->Delete("Sign-On: ");
   msg->headers->Delete("Host: ");
   msg->headers->Delete("Bcc: ");
   msg->headers->Delete("Fcc: ");
   lasterror = 0;

   SetCaption("Connecting...");
   connecting = true;
   SMTP->Connect();
   return true;
}
//---------------------------------------------------------------------------
void __fastcall TSMTPmod::ExceptionHandler(TObject *Sender, Exception *E)
{
   if (SMTP->Connected) SMTP->Abort();
   DISPLAY("Exception: "+E->Message);
   DISPLAY("Send aborted!");
   //SetCaption("Send aborted!");
   aborted = true;
   ShowExitInfo();
}
//---------------------------------------------------------------------------
void __fastcall TSMTPmod::SMTPSessionConnected(TObject *Sender, WORD Error)
{
   if (!Error) SetCaption("Sending message "+s(msgcount-messages->Count)+" of "+s(msgcount));
   else Abort(Error);
}
//---------------------------------------------------------------------------
void __fastcall TSMTPmod::SMTPProcessHeader(TObject *Sender, TStrings *HdrLines)
{
   HdrLines->Text = msg->headers->Text;
}
//---------------------------------------------------------------------------
void __fastcall TSMTPmod::SMTPRequestDone(TObject *Sender, TSmtpRequest RqType,
	WORD Error)
{
   if (canceled) return;
   if (Error)
   {
      Abort(Error);
      return;
   }
   switch (RqType)
   {
      case smtpConnect: SMTP->Helo(); break;
      case smtpHelo: SMTP->MailFrom(); break;
      case smtpMailFrom: SMTP->RcptTo(); break;
      case smtpRcptTo:
         SMTP->Data();
         break;
      case smtpRset:
      case smtpData:
         SMTP->Quit();
         break;
      case smtpQuit:
         break;
   }
}
//---------------------------------------------------------------------------
void __fastcall TSMTPmod::SMTPSessionClosed(TObject *Sender, WORD Error)
{
   display->Add("Connection closed!\r\n");
   if (Error)
   {
      Abort(Error);
      return;
   }
   //if (BytesSent!=BytesTotal && !canceled && !aborted) failed = true;
   GetNextMessage();
}
//---------------------------------------------------------------------------
void __fastcall TSMTPmod::SMTPGetData(TObject *Sender, int LineNum,
	PChar MsgLine, int MaxLen, bool &More)
{
   progressbar->Position = (WORD)(BytesSent/BytesTotal*100); AppProcessMessages();
   if (canceled || aborted || LineNum>msg->body->Count)
   {
      strcpy(MsgLine,"");
      More = false;
      return;
   }

   int wwAt=MaxLen;
   int wwActual=wwAt-1;
   AnsiString s = msg->body->Strings[LineNum-1];
   // currently wraps lines longer than maxlen (1023)
   // but, wwAt can also specify a (viewable) wordwrap length
   if (s.Length()>wwAt)
   {
      for (int i=wwAt; i>0; i--)
         if (s[i]==' ' || s[i]=='-')
         {
            wwActual = i;
            break;
         }
      msg->body->Insert(LineNum,s.SubString(wwActual+1,1023));
      s = s.SubString(1,wwActual);
   }
   strcpy(MsgLine, s.c_str());
   BytesSent += s.Length()+2;
   AllSent += s.Length()+2;
}
//---------------------------------------------------------------------------
void __fastcall TSMTPmod::SMTPDisplay(TObject *Sender, AnsiString Msg)
{
   if (connecting)
   {
      display->Add("Connected to "+SMTP->Host);
      connecting = false;
   }
   if (Msg.SubString(1,1)=="<") display->Add(Msg.SubString(2,255));
}
//---------------------------------------------------------------------------
void __fastcall TSMTPmod::SetCaption(AnsiString cap)
{
   mainwin->ProgressMsg1->Caption = cap;
}
//---------------------------------------------------------------------------
void __fastcall TSMTPmod::ShowExitInfo()
{
   while (SMTP->Connected) AppProcessMessages();
   if (!canceled && !aborted) Global->DB->UnQueueProblem(NULL);
   if ( canceled)
   {
      Global->DB->UnQueueProblem(message);
      Global->DB->QueueMessage(message);
      display->Add(" User canceled send operation!");
      messages->Insert(0,messagekey);
   }
   if (messages->Count)
   {
      AnsiString msgs = messages->Count==1 ? "message":"messages";
      display->Add(" "+s(messages->Count)+" "+msgs+" in queue");
      display->Add("");
   }
   else display->Add("All mail sent!");
   mainwin->SMTPFileCancelSendItem->Enabled = false;
   mainwin->CancelSendBtn->Hide();
   mainwin->OkSentBtn->Show();
   progressbar->Hide();
   SetCaption(" ");
}
//---------------------------------------------------------------------------
